\section{Language Integrated Query (LINQ)}

\includegraphics[width=0.9\linewidth]{query-operators}

\begin{lstlisting}
// Deferred Execution:
string[] cities = { "Bern", "Basel", "Zürich", "Rapperswil", "Genf" };
IEnumerable<string> citiesB = cities.Where(c => c.StartsWith("B"));
// Ausführung:
foreach (string c in citiesB) { /* ... */ }
// Immediate Execution:
// Ausführung
List<string> citiesB = cities
    .Where(c => c.StartsWith("B"))
    .ToList();
// SQL-like Syntax:
int[] numbers = { 0, 1, 2, 3, 4, 5, 6 };
var numQuery =
    from num in numbers
    where (num % 2) == 0
    select num;
// Query ausführen
foreach (int num in numQuery) {
    Console.Write("{0,1} ", num);
}
\end{lstlisting}
\begin{lstlisting}
// Joins
var q = from s in Students
    join m in Markings on s.Id equals m.StudentId
    select s.Name + ", " + m.Course + ", " + m.Mark;
// Group Join
var q = from s in Students
    join m in Markings on s.Id equals m.StudentId
    into list
    select new {
        Name = s.Name,
        Marks = list };
// Multi-Joins / Where / OrderBy
var q = from s in Students
    join m in Markings on s.Id equals m.StudentId
    join c in Courses on c.Id equals m.CourseId
    Where c.Name == "Math" && m.Mark > 4
    orderby s.Name descending, m.Mark
    select new {
        Name = s.Name,
        Mark = m.Mark};
\end{lstlisting}
\begin{lstlisting}
// Grouping
var q = from s in Students
    group s.Name by s.Subject into g
    select new {
        Field = g.Key,
        N = g.Count() };
foreach (var x in q) {
    Console.WriteLine(x.Field + ": " + x.N);
}
// let
var result = from s in Students
    let year = s.Id / 1000
    where year == 2009
    select s.Name + " " + year.ToString();
// SelectMany
List<List<string>> list = new()
{
new() { "a", "b", "c" },
new() { "1", "2", "3" },
new() { "ö", "ä", "ü" }
};
var q1 = list.SelectMany(s => s)
foreach (string line in q1)
{ Console.Write("{0}.", line); }
// Ausgabe: a.b.c.1.2.3.ö.ä.ü.
\end{lstlisting}